import { __decorate } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, EventEmitter, Input, Output, ViewEncapsulation, NgModule } from '@angular/core';
import { NgbDate, NgbDateParserFormatter, NgbDatepickerI18n, NgbCalendar, NgbCalendarIslamicUmalqura, NgbModule } from '@ng-bootstrap/ng-bootstrap';
import * as moment_ from 'moment-hijri';
import * as moment from 'moment';
import { FormsModule } from '@angular/forms';
import { DatePipe, CommonModule } from '@angular/common';

let NgxHijriGregorianDatepickerService = class NgxHijriGregorianDatepickerService {
    constructor() { }
};
NgxHijriGregorianDatepickerService.ɵprov = ɵɵdefineInjectable({ factory: function NgxHijriGregorianDatepickerService_Factory() { return new NgxHijriGregorianDatepickerService(); }, token: NgxHijriGregorianDatepickerService, providedIn: "root" });
NgxHijriGregorianDatepickerService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], NgxHijriGregorianDatepickerService);

let NgxHijriGregorianDatepickerComponent = class NgxHijriGregorianDatepickerComponent {
    constructor() { }
    ngOnInit() {
    }
};
NgxHijriGregorianDatepickerComponent = __decorate([
    Component({
        selector: 'lib-ngx-hijri-gregorian-datepicker',
        template: `
    <p>
      ngx-hijri-gregorian-datepicker works!
    </p>
  `
    })
], NgxHijriGregorianDatepickerComponent);

class DateType {
}
DateType.Hijri = 1;
DateType.Gregorian = 2;

const momentHijri = moment_;
let DateFormatterService = class DateFormatterService {
    constructor(parserFormatter) {
        this.parserFormatter = parserFormatter;
    }
    ToString(date) {
        let dateStr = this.parserFormatter.format(date);
        return dateStr;
    }
    ToBindableHijroDate(hijriDate) {
        let hijriMomentDate = momentHijri(hijriDate, 'iD/iM/iYY HH:mm:ss tt'); // Parse a Hijri date.
        let day = hijriMomentDate.iDate();
        let month = +hijriMomentDate.iMonth() + 1;
        let year = hijriMomentDate.iYear();
        let ngDate = new NgbDate(+year, month, +day);
        return ngDate;
    }
    ToBindableHijroDateUsingFormat(hijriDate, format) {
        let hijriMomentDate = momentHijri(hijriDate, format); // Parse a Hijri date based on format.
        let day = hijriMomentDate.iDate();
        let month = +hijriMomentDate.iMonth() + 1;
        let year = hijriMomentDate.iYear();
        let ngDate = new NgbDate(+year, month, +day);
        return ngDate;
    }
    ToHijri(date) {
        if (!date) {
            return null;
        }
        let dateStr = this.ToString(date);
        let momentDate = momentHijri(dateStr, 'D/M/YYYY');
        let day = momentDate.iDate();
        let month = +momentDate.iMonth() + 1;
        let year = momentDate.iYear();
        let ngDate = new NgbDate(+year, month, +day);
        return ngDate;
    }
    ToGregorian(date) {
        if (!date) {
            return null;
        }
        let dateStr = this.ToString(date);
        let momentDate = momentHijri(dateStr, 'iD/iM/iYYYY');
        let day = momentDate.locale('en').format('D');
        let month = momentDate.locale('en').format('M');
        let year = momentDate.locale('en').format('Y');
        let ngDate = new NgbDate(+year, +month, +day);
        return ngDate;
    }
};
DateFormatterService.ctorParameters = () => [
    { type: NgbDateParserFormatter }
];
DateFormatterService = __decorate([
    Injectable()
], DateFormatterService);

const momentHijri$1 = moment_;
let HijriGregorianDatepickerComponent = class HijriGregorianDatepickerComponent {
    constructor(dateFormatterService) {
        this.dateFormatterService = dateFormatterService;
        this.selectedDateType = DateType.Hijri;
        this.selectedDateChange = new EventEmitter();
        this.readonly = false;
        this.isRequired = false;
        this.disabled = false;
    }
    get DateType() {
        return DateType;
    }
    ngOnInit() {
    }
    getSelectedDate() {
        let formattedDate = this.dateFormatterService.ToString(this.selectedDate);
        if (this.selectedDateType == DateType.Hijri) {
            return momentHijri$1(formattedDate, 'iD/iM/iYYYY').locale('en').format();
        }
        if (this.selectedDateType == DateType.Gregorian) {
            return moment(formattedDate, 'D/M/YYYY').locale('en').format();
        }
    }
    dateSelected() {
        this.selectedDateChange.emit(this.selectedDate);
    }
    hijriClick() {
        if (this.selectedDateType == DateType.Hijri) {
            return;
        }
        this.selectedDateType = DateType.Hijri;
        //to hijri
        this.selectedDate = this.dateFormatterService.ToHijri(this.selectedDate);
        this.selectedDateChange.emit(this.selectedDate);
    }
    gregClick() {
        if (this.selectedDateType == DateType.Gregorian) {
            return;
        }
        this.selectedDateType = DateType.Gregorian;
        //to Gregorian
        this.selectedDate = this.dateFormatterService.ToGregorian(this.selectedDate);
        this.selectedDateChange.emit(this.selectedDate);
    }
};
HijriGregorianDatepickerComponent.ctorParameters = () => [
    { type: DateFormatterService }
];
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "selectedDate", void 0);
__decorate([
    Output()
], HijriGregorianDatepickerComponent.prototype, "selectedDateChange", void 0);
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "label", void 0);
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "readonly", void 0);
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "isRequired", void 0);
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "disabled", void 0);
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "minHijri", void 0);
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "maxHijri", void 0);
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "minGreg", void 0);
__decorate([
    Input()
], HijriGregorianDatepickerComponent.prototype, "maxGreg", void 0);
HijriGregorianDatepickerComponent = __decorate([
    Component({
        selector: 'hijri-gregorian-datepicker',
        template: "\n    <div class=\"form-group\">\n      <label class=\"requiredInput\" for=\"input-birth-Date\">{{ label }} </label>\n\n      <div class=\"input-group\">\n\n          <input  class=\"form-control\"\n                  placeholder=\"d/M/yyyy\"\n                  [name]=\"label\"\n                  *ngIf=\"selectedDateType == DateType.Gregorian\"\n                  [(ngModel)]=\"selectedDate\"\n                  ngbDatepicker (click)=\"d.toggle()\"\n                  (dateSelect)=\"dateSelected()\"\n                  autocomplete=\"off\"\n                  #d=\"ngbDatepicker\"\n                  [readonly]=\"readonly\"\n                  [minDate]=\"minGreg\"\n                  [maxDate]=\"maxGreg\"\n                  [required]=\"isRequired\"\n                  [disabled]=\"disabled\">\n\n\n          <hijri-date-picker *ngIf=\"selectedDateType == DateType.Hijri\"\n                             [(selectedDate)]=\"selectedDate\"\n                             (selectedDateChange)=\"dateSelected()\"\n                             [readonly]=\"readonly\"\n                             [min]=\"minHijri\" [max]=\"maxHijri\"\n                             style=\"flex: 1 1 auto;\"\n                             [name]=\"label\"\n                             [isRequired]=\"isRequired\"\n                             [disabled]=\"disabled\">\n          </hijri-date-picker>\n\n          <div class=\"input-group-append\">\n                  <button class=\"btn btn-sm {{selectedDateType == DateType.Hijri ? 'btn-info focus active' :  'btn-outline-info'}}\" (click)=\"hijriClick()\"  [disabled]=\"disabled\" type=\"button\"> Hijri</button>\n                  <button class=\"btn btn-sm {{selectedDateType == DateType.Gregorian ? 'btn-info focus active' :  'btn-outline-info'}}\" (click)=\"gregClick()\" [disabled]=\"disabled\" type=\"button\">Gregorian</button>\n           </div>\n\n      </div>\n  </div>\n"
    })
], HijriGregorianDatepickerComponent);

const WEEKDAYS = ['أحد', 'إثنين', 'ثلاثاء', 'أربعاء', 'خميس', 'جمعة', 'سبت'];
const MONTHS = ['محرم', 'صفر', 'ربيع الأول', 'ربيع الآخر', 'جمادى الأولى', 'جمادى الآخرة', 'رجب', 'شعبان', 'رمضان', 'شوال',
    'ذو القعدة', 'ذو الحجة'];
let IslamicI18n = class IslamicI18n extends NgbDatepickerI18n {
    getWeekdayShortName(weekday) {
        return WEEKDAYS[weekday - 1];
    }
    getMonthShortName(month) {
        return MONTHS[month - 1];
    }
    getMonthFullName(month) {
        return MONTHS[month - 1];
    }
    getDayAriaLabel(date) {
        return `${date.day}-${date.month}-${date.year}`;
    }
};
IslamicI18n = __decorate([
    Injectable()
], IslamicI18n);

let HijriDatepickerComponent = class HijriDatepickerComponent {
    constructor() {
        this.selectedDateChange = new EventEmitter();
        this.readonly = false;
        this.isRequired = false;
        this.disabled = false;
    }
    changeDate() {
        this.selectedDateChange.emit(this.selectedDate);
    }
    onBlur() {
        if (!this.selectedDate) {
            this.selectedDateChange.emit(null);
        }
    }
};
__decorate([
    Input()
], HijriDatepickerComponent.prototype, "selectedDate", void 0);
__decorate([
    Output()
], HijriDatepickerComponent.prototype, "selectedDateChange", void 0);
__decorate([
    Input()
], HijriDatepickerComponent.prototype, "readonly", void 0);
__decorate([
    Input()
], HijriDatepickerComponent.prototype, "isRequired", void 0);
__decorate([
    Input()
], HijriDatepickerComponent.prototype, "disabled", void 0);
__decorate([
    Input()
], HijriDatepickerComponent.prototype, "min", void 0);
__decorate([
    Input()
], HijriDatepickerComponent.prototype, "max", void 0);
__decorate([
    Input()
], HijriDatepickerComponent.prototype, "name", void 0);
HijriDatepickerComponent = __decorate([
    Component({
        selector: 'hijri-date-picker',
        template: "<input\n    class=\"form-control hijriInput\"\n    [(ngModel)]=\"selectedDate\"\n    placeholder=\"d/M/yyyy\"\n    ngbDatepicker\n    (click)=\"d.toggle()\"\n    (dateSelect)=\"changeDate()\"\n    #d=\"ngbDatepicker\"\n    [readonly]=\"readonly\"\n    [minDate]=\"min\"\n    [maxDate]=\"max\"\n    [required]=\"isRequired\"\n    [name]=\"name\"\n    (blur)=\"onBlur()\"\n    [disabled]=\"disabled\" />\n",
        providers: [
            { provide: NgbCalendar, useClass: NgbCalendarIslamicUmalqura },
            { provide: NgbDatepickerI18n, useClass: IslamicI18n }
        ],
        encapsulation: ViewEncapsulation.None,
        styles: [".hijriInput{border-bottom-left-radius:0;border-top-left-radius:0}.ngb-dp-weekday{width:2.1rem!important}"]
    })
], HijriDatepickerComponent);

class CustomNgbDateParserFormatter extends NgbDateParserFormatter {
    constructor(dateFormatString) {
        super();
        this.dateFormatString = dateFormatString;
        this.datePipe = new DatePipe('en-US');
    }
    format(date) {
        if (date === null) {
            return '';
        }
        try {
            return this.datePipe.transform(new Date(date.year, date.month - 1, date.day), this.dateFormatString);
        }
        catch (e) {
            return '';
        }
    }
    parse(value) {
        let returnVal;
        if (!value) {
            returnVal = null;
        }
        else {
            try {
                let dateParts = this.datePipe.transform(value, 'M-d-y').split('-');
                returnVal = { year: parseInt(dateParts[2]), month: parseInt(dateParts[0]), day: parseInt(dateParts[1]) };
            }
            catch (e) {
                returnVal = null;
            }
        }
        return returnVal;
    }
}

let NgxHijriGregorianDatepickerModule = class NgxHijriGregorianDatepickerModule {
};
NgxHijriGregorianDatepickerModule = __decorate([
    NgModule({
        declarations: [NgxHijriGregorianDatepickerComponent,
            HijriGregorianDatepickerComponent,
            HijriDatepickerComponent],
        imports: [
            CommonModule,
            FormsModule,
            NgbModule
        ],
        providers: [
            DateFormatterService,
            {
                provide: NgbDateParserFormatter, useFactory() {
                    return new CustomNgbDateParserFormatter('d/M/yyyy');
                }
            }
        ],
        exports: [HijriGregorianDatepickerComponent, NgxHijriGregorianDatepickerComponent]
    })
], NgxHijriGregorianDatepickerModule);

/*
 * Public API Surface of ngx-hijri-gregorian-datepicker
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DateFormatterService, HijriGregorianDatepickerComponent, NgxHijriGregorianDatepickerComponent, NgxHijriGregorianDatepickerModule, NgxHijriGregorianDatepickerService, HijriDatepickerComponent as ɵa, IslamicI18n as ɵb };
//# sourceMappingURL=ngx-hijri-gregorian-datepicker.js.map
